#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

using SLIME = array<pair<int, int>, 4>;

int dx[8] = {0, 0, -1, 1, 1, 1, -1, -1};
int dy[8] = {-1, 1, 0, 0, -1, 1, -1, 1};

vector<vector<ll>> h;

struct HASH {
    ll operator()(const SLIME& a) const {
        ll res = 0;
        for (int i = 0; i < 4; i++) res ^= h[a[i].first + 5][a[i].second + 5];
        return res;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> f(n, vector<char>(m));

    h.assign(n + 16, vector<ll>(m + 16));
    for (int i = 0; i < n + 16; i++) for (int j = 0; j < m + 16; j++) h[i][j] = rnd();

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j];
        }
    }

    unordered_map<SLIME, int, HASH> dist;

    auto check_comp = [&](SLIME& a) {
        int c = 0;
        for (int i = 0; i < 4; i++) {
            for (int j = i + 1; j < 4; j++) {
                if (a[i] == a[j]) return false;

                if ((abs(a[i].first - a[j].first) + abs(a[i].second - a[j].second)) == 1) {
                    c++;
                }
            }
        }
        return c >= 3;
    };

    auto check = [&](SLIME& a) {
        for (int i = 0; i < 4; i++) {
            auto [x, y] = a[i];
            if (x < 0 || x >= n || y < 0 || y >= m) return false;
            if (f[x][y] == '#') return false;
        }
        return true;
    };

    deque<SLIME> q;
    SLIME start;
    start[0] = {0, 0};
    start[1] = {0, 1};
    start[2] = {1, 0};
    start[3] = {1, 1};
    q.push_back(start);
    dist[start] = 1;

    SLIME finish;
    finish[0] = {n - 2, m - 2};
    finish[1] = {n - 2, m - 1};
    finish[2] = {n - 1, m - 2};
    finish[3] = {n - 1, m - 1};

    unordered_map<SLIME, vector<SLIME>, HASH> g;

    auto get_base = [&](SLIME& a) {
        SLIME res;
        for (int i = 0; i < 4; i++) res[i] = {a[i].first - a[0].first, a[i].second - a[0].second};
        return res;
    };

    auto build = [&](SLIME& base) {
        if (!g[base].empty()) return;

        for (int i = 0; i < 4; i++) {
            for (int k = 0; k < 8; k++) {
                SLIME nv = base;
                nv[i].first += dx[k];
                nv[i].second += dy[k];
                sort(nv.begin(), nv.end());
                if (check_comp(nv)) {
                    g[base].push_back(nv);
                }
            }
        }
    };

    while (!q.empty()) {
        SLIME cur = q.front();
        q.pop_front();

//        for (auto [x, y] : cur) cout << x << ' ' << y << '\n';
//        cout  << '\n';

        SLIME base = get_base(cur);
        build(base);
        for (auto nxt : g[base]) {
            for (auto& el : nxt) {
                el.first += cur[0].first;
                el.second += cur[0].second;
            }
            if (check(nxt) && !dist[nxt]) {
                dist[nxt] = dist[cur] + 1;
                q.push_back(nxt);
                if (nxt == finish) {
                    cout << dist[finish] - 1 << '\n';
                    return 0;
                }
            }
        }
    }

    cout << dist[finish] - 1 << '\n';

    return 0;
}