#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int n = 10;

bool check(int i, int j, vector<vector<char>>& data){
    if (i > 0){
        if (j > 0){
            if (data[i - 1][j - 1] == '#'){
                return false;
            }
        }
        if (j < n - 1){
            if (data[i - 1][j + 1] == '#'){
                return false;
            }
        }
    }
    if (i < n - 1){
        if (j > 0){
            if (data[i + 1][j - 1] == '#'){
                return false;
            }
        }
        if (j < n - 1){
            if (data[i + 1][j + 1] == '#'){
                return false;
            }
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    vector<vector<char>> data(n, vector<char> (n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> data[i][j];
        }
    }

    set<pair<int, int>> gu;

    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            gu.insert(make_pair(i, j));
        }
    }

    vector<int> palubniki(5, 0);
    while (not gu.empty()) {
        pair<int, int> elem = *gu.begin();
        int i = elem.first, j = elem.second;
        gu.erase(elem);
        if (data[i][j] == '#') {
            int up = 0, down = 0, left = 0, right = 0, t = i - 1;
            if (not check(i, j, data)) {
                cout << "NO";
                return 0;
            }
            while (t >= 0 and data[t][j] == '#'){
                up++;
                if (not check(t, j, data)) {
                    cout << "NO";
                    return 0;
                }
                gu.erase(make_pair(t, j));
                t--;
            }
            t = i + 1;
            while (t < n and data[t][j] == '#'){
                down++;
                if (not check(t, j, data)) {
                    cout << "NO";
                    return 0;
                }
                gu.erase(make_pair(t, j));
                t++;
            }
            t = j + 1;
            while (t < n and data[i][t] == '#'){
                right++;
                if (not check(i, t, data)) {
                    cout << "NO";
                    return 0;
                }
                gu.erase(make_pair(i, t));
                t++;
            }
            t = j - 1;
            while (t >= 0 and data[i][t] == '#'){
                left++;
                if (not check(i, t, data)) {
                    cout << "NO";
                    return 0;
                }
                gu.erase(make_pair(i, t));
                t--;
            }
            if ((up + down) >= 1 and (left + right) >= 1){
                cout << "NO";
                return 0;
            } else if ((up + down) > 0) {
                ++palubniki[up + down + 1];
            } else if ((left + right) > 0) {
                ++palubniki[left + right + 1];
            } else {
                palubniki[1]++;
            }
        }
    }

    if (palubniki[4] == 1 and palubniki[3] == 2 and palubniki[2] == 3 and palubniki[1] == 4)
        cout << "YES";
    else
        cout << "NO";


    return 0;
}
