#include<iostream>
#include<algorithm>
#include<set>
#include<string>
#include<vector>
#include<cmath>

using namespace std;

long double bin_pow(long double a, int n) {
	if (n == 0) {
		return (long double)1;
	}
	long double x = bin_pow(a, n / 2);
	long double ans = x * x;
	if (n % 2) {
		ans *= a;
	}
	return ans;
}

int main() {
	int n, m;
	cin >> n >> m;
	long double r;
	cin >> r;
	vector<pair<int, long double>> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}
	cout.precision(20);
	sort(v.begin(), v.end());
	vector<long double> ans(n);
	ans[0] = r * v[0].second;
	for (int i = 1; i < n; i++) {
		ans[i] = ans[i - 1] * bin_pow(1 - r, v[i].first - v[i - 1].first) + r * v[i].second;
		// << ans[i] << "!\n";
	}
	for (int i = 0; i < m; i++) {
		int q;
		cin >> q;
		pair<int, long double> zn = { q, 1e18 };
		auto it = upper_bound(v.begin(), v.end(), zn);
		if (it == v.begin()) {
			cout << "0 ";
			continue;
		}
		it--;
		int nb = it - v.begin();
		//cout << nb << "???\n";
		auto e = *it;
		//cout << e.first << " " << e.second << " " << ans[nb] << "?\n";
		long double answer = ans[nb] * bin_pow(1 - r, q - e.first);
		cout << answer << " ";
	}
	cout << "\n";
}