#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> pair_) {
    in >> pair_.first >> pair_.second;
    return in;
}
template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> pair_) {
    out << pair_.first << " " << pair_.second;
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &arr_) {
    for (auto &_ : arr_) {
        in >> _;
    }
    return in;
}
template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr_) {
    for (auto &_ : arr_) {
        out << _ << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)

const int INT_INF = INT_MAX;

struct node {
    int mx, ind;

    node() : mx(INT_INF), ind(-1) {}

    node(int mx, int ind) : mx(mx), ind(ind) {}
};

node operator+(const node &a, const node &b) {
    if (a.mx >= b.mx) {
        return node(a.mx, a.ind);
    }
    return node(b.mx, b.ind);
}

struct tree_of_segs {
    int sz;
    vector<int> a;
    vector<node> t;

    void init(vector<int> &arr) {
        sz = (int) arr.size();
        a = arr;
        t.resize(4 * sz);
        build(0, 0, sz);
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = node(a[l], l);
            return;
        }
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        build(l_u, l, m);
        build(r_u, m, r);
        t[v] = t[l_u] + t[r_u];
    }

    node get(int l, int r) {
        return getlr(0, 0, sz, l, r);
    }

    node getlr(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return node();
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        node res_l_u = getlr(l_u, l, m, ql, qr);
        node res_r_u = getlr(r_u, m, r, ql, qr);
        node res = res_l_u + res_r_u;
        return res;
    }
};

vector<int> h, c;

tree_of_segs ts;

ll get(int l, int r) { // [l; r]
    if (l == r) {
        return c[l];
    }
    if (l > r) {
        return 0;
    }
    int ind = ts.get(l, r + 1).ind;
    ll res_l = get(l, ind - 1), res_r = get(ind + 1, r);
    ll ans = c[ind] + min(res_l, res_r);
    return ans;
}

int main() {
    int n;
    cin >> n;
    h.resize(n);
    cin >> h;
    c.resize(n);
    cin >> c;

    ts.init(h);

    ll ans = get(0, n - 1);
    cout << ans;
}
