#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> pair_) {
    in >> pair_.first >> pair_.second;
    return in;
}
template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> pair_) {
    out << pair_.first << " " << pair_.second;
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &arr_) {
    for (auto &_ : arr_) {
        in >> _;
    }
    return in;
}
template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr_) {
    for (auto &_ : arr_) {
        out << _ << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)
#define endl "\n";

struct d_w {
    int d, w;

    d_w() : d(0), w(0) {}
};

bool cmp(const d_w &a, const d_w &b) {
    return a.d < b.d;
}

ld get_deg(ld x, int deg) {
    if (deg == 0) {
        return 1;
    }
    if (deg % 2 == 0) {
        ld ans = get_deg(x, deg / 2);
        ans *= ans;
        return ans;
    } else {
        ld ans = get_deg(x, deg - 1);
        ans *= x;
        return ans;
    }
}

ld r;

ld get(ld x, int cnt) {
    ld res = x * get_deg(1 - r, cnt);
    return res;
}

int main() {
    int n, q;
    cin >> n >> q;
    cin >> r;
    vector<d_w> a(n);
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].d >> a[i].w;
    }

    sort(all(a), cmp);
    for (int i = 0; i < n; i++) {
        d[i] = a[i].d;
    }

    vector<ld> days(n);
    days[0] = 0 + r * a[0].w;
    for (int i = 1; i < n; i++) {
        days[i] = get(days[i - 1], a[i].d - a[i - 1].d) + r * a[i].w;
    }

    cout.precision(32);
    for (int i = 0; i < q; i++) {
        int day;
        cin >> day;
        if (day < a[0].d) {
            cout << 0 << " ";
            continue;
        }
        int ind = upper_bound(all(d), day) - d.begin() - 1;
        ld ans = get(days[ind], day - a[ind].d);
        cout << ans << " ";
    }
}
