#include <iostream>
#include <vector>
#include <set>

using namespace std;

void read_g(int m, set <pair <int, int>> &g, vector <int> &deg) {
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if (a > b) {
            swap(a, b);
        }
        g.insert({a, b});
        deg[a]++;
        deg[b]++;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;

    set <pair <int, int>> g1, g2;
    vector <int> deg1(n + 1, 0), deg2(n + 1, 0);

    read_g(m, g1, deg1);
    read_g(k, g2, deg2);

    for (int i = 1; i <= n; i++) {
        if ((deg1[i] % 2) != (deg2[i] % 2)) {
            cout << "NO\n";
            return 0;
        }
    }

    vector <pair <int, int>> diff_edges;
    for (auto edge : g1) {
        if (g2.find(edge) == g2.end() && edge.first != 1 && edge.second != 1) {
            diff_edges.push_back(edge);
        }
    }
    for (auto edge : g2) {
        if (g1.find(edge) == g1.end() && edge.first != 1 && edge.second != 1) {
            diff_edges.push_back(edge);
        }
    }
    
    
    cout << "YES\n";
    cout << diff_edges.size() << '\n';
    for (auto [u, v] : diff_edges) {
        cout << 1 << ' ' << u << ' ' << v << '\n';
    }
    return 0;
}