#include <iostream>

typedef long long ll;

const int N = 200000;
int h[N], c[N];

int cnt_v;
int tree[N * 4];

void build(int n) {
    cnt_v = 1;
    while (cnt_v < n) {
        cnt_v <<= 1;
    }
    for (int i = 0; i < n; ++i) {
        tree[cnt_v - 1 + i] = h[i];
    }
    for (int i = cnt_v - 2; i >= 0; --i) {
        tree[i] = std::max(tree[i * 2 + 1], tree[i * 2 + 2]);
    }
}

std::pair<int, int> get_highest(int x, int lx, int rx, int l, int r) {
    if (lx >= r || l >= rx) {
        return {0, -1};
    } else if (lx >= l && rx <= r) {
        if (rx - lx == 1) {
            return {tree[x], lx};
        } else if (tree[x * 2 + 1] > tree[x * 2 + 2]) {
            return get_highest(x * 2 + 1, lx, (lx + rx) / 2, l, r);
        } else {
            return get_highest(x * 2 + 2, (lx + rx) / 2, rx, l, r);
        }
    } else {
        return std::max(get_highest(x * 2 + 1, lx, (lx + rx) / 2, l, r), get_highest(x * 2 + 2, (lx + rx) / 2, rx, l, r));
    }
}

ll solve(int l, int r) {
    if (r - l == 0) {
        return 0LL;
    } else {
        int m = get_highest(0, 0, cnt_v, l, r).second;
        return c[m] + std::min(solve(l, m), solve(m + 1, r));
    }
}

int main() {
    int n;
    std::cin >> n;
    for (int i = 0; i < n; ++i) {
        std::cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> c[i];
    }

    build(n);

    std::cout << solve(0, n) << "\n";
}