//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  vector<string> field(n);
  for (auto& s : field) {
    cin >> s;
  }
  auto ok = [&](int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m && field[i][j] == '.';
  };
  vector dist(n, vector<int>(m, -1));
  queue<pair<int, int>> q;
  for (int i = 0; i < 2; ++i) {
    for (int j = 0; j < 2; ++j) {
      dist[i][j] = 0;
      q.emplace(i, j);
    }
  }
  vector<int> DX{1, 0, -1, 0};
  vector<int> DY{0, 1, 0, -1};
  int cnt = 0;
  while (!q.empty()) {
    auto[r, c] = q.front(); q.pop();
    if (r >= n - 2 && c >= m - 2) {
      if (++cnt == 4) {
        cout << dist[r][c] << '\n';
        return 0;
      }
    }
    for (int t = 0; t < 4; ++t) {
      int rr = r + DX[t];
      int cc = c + DY[t];
      if (ok(rr, cc)) {
        if (dist[rr][cc] < 0) {
          dist[rr][cc] = dist[r][c] + 1;
          q.emplace(rr, cc);
        }
      }
    }
  }
  cout << -1 << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
