/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<int, double> pid;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    in(double, r)
    vector<pid> days(n);
    for (int i = 0; i < n; i++) {
        cin >> days[i].first >> days[i].second;
    }
    sort(all(days));

    double day_value = 0;
    int last_day = 0;
    for (int i = 0; i < n; i++) {
        auto [day, inc] = days[i];
        while (last_day < day) {
            last_day++;
            day_value *= 1 - r;
        }
        day_value += r * inc;
        days[i].second = day_value;
    }

    cout.precision(12);
    for (int i = 0; i < m; i++) {
        in(int, q)
        int d = -1;
        while (d + 1 < n && days[d + 1].first <= q) d++;
        if (d == -1) {
            cout << 0 << ' ';
        } else {
            double value = days[d].second;
            for (int day = days[d].first; day < q; day++) {
                value *= 1 - r;
            }
            cout << value << ' ';
        }
    }
    cout << '\n';

}